//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FFT4_class.h"
#include <math.h>
#include <mem.h>

#include "Unit2.h"
#include "Unit3.h"
/************************************************/
/*
/*  4{TvǑvZp3{̃tB^[vZ
/*
/*  }̂Ɂ@ʂ̂ehqtB^[@koe
/*  4TvɁiقƂǁjɂȂehqtB^[@koeǉB
/*
/************************************************/
/*
/*  2011N123|4@FFTẐȂŗ]ȂƂX
/*  Overlap-save @ǉ FIR̓JCUC[LPFgp
/*
/*************************************************/



//#include "main1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//-----------------------------------------------------------
TFFT4_class::TFFT4_class(int num_hani, float fc_fs_rate, float BAND_GENSUI_DB, float BANDWIDE_RATE, int mode0, int core_number)
//
//  mode == 0 TvO藝ɂƂÂvZ
//  mode == 1 }ŁAʂ̂ehqtB^[@koe
//  mode == 2 }Ł@4TvɁiقƂǁjɂȂehqtB^[@koe
//
//  mode == 3 JbgLPF݂ŌvZ
//  mode == 4 JbgLPFłȊO̓pX
//
{
      int   kaiser_nzyou,i,j,k,c0;
      double  sin1_4,x0;


      rt_code0=0;
      core_number0=core_number;
      fft4_fil0= FFT4_FIL0A;  // default 1
      fft4_ste0= FFT4_STEP0;  // default 4


      if( mode0 == 0)
      {
          num_hanix=num_hani;
          // S  2 * num_hanix)-1
          kaiser_nzyou=int(ceil(log( (double)((2 * num_hanix)-1))  /log(2.0)  ));
          use_fir_lpf1_flag=false;
          
      }
      else if( (mode0 == 3) || (mode0 ==4))
      {
           // 0-3 fir ׂČvZɂ
           fft4_fil0= FFT4_FIL0B;

           // TvO藝ɂW@S  2 * num_hanix)-1
            num_hanix=num_hani;

           // tB^[̌W@S com_order = com_order2 * 2 + 1
           use_fir_lpf1_flag= init_fir_lpf1(fc_fs_rate, BAND_GENSUI_DB, BANDWIDE_RATE, mode0);   // 

           if( mode0 ==3)
           {
             //num_hanix= (2 * num_hanix-1) + com_order - 1; //S
             kaiser_nzyou=int(ceil(log( (double)((2 * num_hanix)-1) + com_order - 1)  /log(2.0)  ));


           }
           else  // mod0e ==4
           {
              kaiser_nzyou=int(ceil(  log( (double)com_order)  /log(2.0)  ) );
              //num_hanix = com_order2 +1;
              fft4_ste0=1;  // vZ1񕪂݂̂ɐݒ
           }

      }
      else
      {
          if( mode0 == 1) fft4_fil0= FFT4_FIL0B;  // ʂ̂ehq@koe͂ԌvZ
          use_fir_lpf1_flag= init_fir_lpf1(fc_fs_rate, BAND_GENSUI_DB, BANDWIDE_RATE, mode0);
          nfir_1_4= int(ceil((double)com_order / (double)FFT4_STEP0));
          kaiser_nzyou=int(ceil(  log( (double) nfir_1_4  )  /log(2.0)  )); // FFT4_STEP0 ̔{ɊZB
      }

////Form2->Memo1->Lines->Add(" mode0= "  + IntToStr(mode0) +  " kaiser_nzyou= " + IntToStr(kaiser_nzyou) + " com_order= " + IntToStr(com_order));


      // Form2->Memo1->Lines->Add(" kaiser_nzyou = " + IntToStr(kaiser_nzyou));
      nzyou0= kaiser_nzyou+1; // 2{@Ol߁@̂͗f[^
      nzyoux= nzyou0;
      len0=f_zyou( nzyou0);
      len0_half=len0/2;

      for(i=FFT4_FIL0B;i<FFT4_STEP0;++i)
      ////for(i=fft4_fil0;i<FFT4_STEP0;++i)
      {
       if((pp0[i]  =(double *)malloc( 2 * (len0+1) * sizeof(double)))==NULL) rt_code0+=1;
       else
       {
         // ׂĂɗĂB
         memset((char *)pp0[i], 0, 2 * len0 * sizeof(double));
       }

      }

      if( (mode0 == 0) || (mode0 == 3) || (mode0 == 4))
      {
         // CpX͓߂ŁA㔼ɗǉ[iݍ݂́j㔼ݍ݂ƓɂȂ邻B
         bn1=1.0 /(double) len0;


        if( (mode0 == 0) || (mode0 == 3))
        {
         sin1_4=sin(M_PI_4);

         kaiser_lpf=pp0[1];
         kaiser_lpf2=pp0[2];
         kaiser_lpf3=pp0[3];

         i=num_hanix-1;
         kaiser_lpf[2*i]=sin1_4 / M_PI_4 * bn1;
         kaiser_lpf2[2*i]=1.0 /  M_PI_2 * bn1;
         kaiser_lpf3[2*i]=sin1_4 / (3. * M_PI_4) * bn1;
         *(pp0[0]+ (2*i)) =1. * bn1;  // Z^[ɂPݒ肷B

         // h(i) * x(N-i) ƌvZtɂȕAh(i)̏ԂtɂB
         for(i=1; i < num_hanix; ++i)
        {
          kaiser_lpf[2*(i+num_hanix-1)] =sin1_4 / ( M_PI_4  + (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf[2*(i+num_hanix-1)]= -1. * kaiser_lpf[2*(i+num_hanix-1)];
          kaiser_lpf[2*(num_hanix-1-i)] =sin1_4 / ( M_PI_4  - (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf[2*(num_hanix-1-i)]= -1. * kaiser_lpf[2*(num_hanix-1-i)];

          kaiser_lpf3[2*(i+num_hanix-1)] =sin1_4 / ( (3. *  M_PI_4)  + (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf3[2*(i+num_hanix-1)]= -1. * kaiser_lpf3[2*(i+num_hanix-1)];
          kaiser_lpf3[2*(num_hanix-1-i)] =sin1_4 / ( (3. *  M_PI_4)  - (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf3[2*(num_hanix-1-i)]= -1. * kaiser_lpf3[2*(num_hanix-1-i)];

          kaiser_lpf2[2*(i+num_hanix-1)] =  1.0 / ( M_PI_2  + (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf2[2*(i+num_hanix-1)]= -1. * kaiser_lpf2[2*(i+num_hanix-1)];
          kaiser_lpf2[2*(num_hanix-1-i)] = 1.0 / ( M_PI_2 - (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf2[2*(num_hanix-1-i)]= -1. * kaiser_lpf2[2*(num_hanix-1-i)];

        }
        } // end of if( (mode0 == 0) || (mode0 == 3))


//Form2->Memo1->Lines->Add(" fft4 init pass1");


          if( mode0 ==3)
          {
             if( (2 * num_hanix -1 ) > com_order)
             {
                for(k=0;k<FFT4_STEP0;++k)  // 4{̌WvZ
                {
                   for(i=0;i<(2 * num_hanix -1 + com_order -1 );++i) // Q̃CpX|킷
                   {
                      x0=0.;
                      for(j=0;j<(2 * num_hanix -1 );++j) // ̌W̌@a
                      {
                         c0=i-j;
                         if( (c0 >=0) && ( c0 < com_order))
                         {
                          x0 += (fir_lpf1[c0] * *(pp0[k]+ 2*j));
                         }
                      }
                      *(pp0[k]+ 2*i+1)=x0;  // U@ɒlޔĂ
                   }

                   // ޔĂf[^ɖ߂
                   for(i=0;i<(2 * num_hanix -1 + com_order -1 );++i)
                   {
                      *(pp0[k]+ 2*i) = *(pp0[k]+ 2*i+1);
                      *(pp0[k]+ 2*i+1)=0.;
                   }
                }


             }
             else
             {
                //@t̏ꍇ͖
             }
             num_hanix =  num_hanix-1 + com_order2 + 1;  // xʂɍXɒS݂Ȃ̂1
          }
          else if(mode0 ==4)
          {
             // pp0[0] ɒLPF̃CpXi[
             kaiser_lpf=pp0[0];
             for(i=0;i<com_order;++i)  kaiser_lpf[2*i]= fir_lpf1[i] * bn1;
             num_hanix =  com_order2 + 1;  // xʂɍXɒS݂Ȃ̂1
          }

      ////Form1->Memo1->Lines->Add("+FFT2_class");
      ////for(i=0;i<(len0/2);++i) Form2->Memo1->Lines->Add(" No." + IntToStr(i) + " value=" + FloatToStr(kaiser_lpf2[2*i]));
     }
     else
     {    bn1=1.0 /(double) len0;
          bn2= bn1 * gain_hosei1; 
          /* for debug only! */
          ////bn2=1.0;
          /*-----------------*/
          for(i=FFT4_FIL0B;i<FFT4_STEP0;++i)    // Ƃ肠@S@Ă
          //for(i=fft4_fil0;i<FFT4_STEP0;++i)
          {
             kaiser_lpf=pp0[i];
             for(j=0;j< nfir_1_4 ;++j)   // FFT4_STEP0 VtgĒl
             {
              c0= FFT4_STEP0 * j + i;
              if(c0 < com_order)  kaiser_lpf[2*j]= fir_lpf1[c0] * bn2; 
             }
          }

          if( mode0 ==1)
          {
             num_hanix = 1;   // bȒPɂ邽߁Anum_hanix center̂PĂB@ǂ݃f[^͗ƂȂ
                              // vZꂽf[^ń@com_order2@fB[ɂɂȂB
          }
          else if( mode0 == 2)
          {
              num_hanix = (com_order2/FFT4_STEP0) + 1;   // x@Vtg؂̂Ł@ǂ݂Ă݂B
          }
/*******
for(j=0;j<4;++j)
{
kaiser_lpf=pp0[j];
Form2->Memo1->Lines->Add(" Shift No. "  + IntToStr(j));
for(i=0;i<(len0/2);++i) Form2->Memo1->Lines->Add(" No." + IntToStr(i+1) + " value=" + FloatToStr(kaiser_lpf[2*i]));
}
******/
     }

//Form2->Memo1->Lines->Add(" fft4 init pass2");

     f_iv_mkdat( nzyou0);
     f_mkdat( nzyou0 );
     f_bitrev( nzyou0 );
     if((works =(double *)malloc( 2 * (len0+1) * sizeof(double)))==NULL) rt_code0+=100;
     if((works2=(double *)malloc( 2 * (len0+1) * sizeof(double)))==NULL) rt_code0+=200;


     // kaiser_lpf ́@FFTvZĂ
       for(i=fft4_fil0;i<fft4_ste0;++i)
       {
         f_fft( pp0[i], 0, -1);
       }



     /*
     // for debug set real all 1
     for(i=0;i<(len0);++i)
     {
       kaiser_lpf[2*i]=1.0 * bn1;
       kaiser_lpf[2*i+1]=0.0;
       kaiser_lpf2[2*i]=1.0 * bn1;
       kaiser_lpf2[2*i+1]=0.0;
       kaiser_lpf3[2*i]=1.0 * bn1;
       kaiser_lpf3[2*i+1]=0.0;
       Form2->Memo1->Lines->Add(" No." + IntToStr(i) + " value=" + FloatToStr(kaiser_lpf2[2*i]));
     }
     // end of for debug set real all 1
     */



     // ̓f[^̎̂߂ɕۑĂ
     works_half=(double *)malloc( (2 * (len0+1) /2)  * sizeof(double));
     if( mode0 == 0 ) iwork_half=(short *)malloc( len0_half * 2 * sizeof(short));
     else iwork_half=(short *)malloc( com_order2 * 2 * sizeof(short));
}
//----------------------------------------------------------
TFFT4_class::~TFFT4_class()
{
     int i;

     free(ivmk);
     free(mk);
     free(table);
     free(works);
     free(works2);
     for(i=fft4_fil0;i<FFT4_STEP0;++i)  free( pp0[i]);
     free(works_half);
     free(iwork_half);
     if( use_fir_lpf1_flag ) free(fir_lpf1);

}
//-----------------------------------------------------------
int TFFT4_class::f_zyou( int zyou)
{
   if( zyou < 0)
   {
     return(1);
   }
   else return( 1 << zyou);
}
//----------------------------------------------------------------------------
double TFFT4_class::bessel0(double x0)
{
#define NUM0 40

  int i;
  double y0,r0,u2,u20,y1;

  y0=1.;
  r0=1.;
  u20=x0/2.0;
  u2=u20;
  y1=u2 / r0;
  y1=y1 * y1;
  y0=y0+y1;

  for(i=2;i<NUM0;++i)
  {
      r0=r0 * (double)i;
      u2=u2*u20;
      y1=u2 / r0;
      y1=y1 * y1;
      y0=y0 + y1;
  }
  return y0;
}
//----------------------------------------------------------------------------
bool TFFT4_class::init_fir_lpf1(float fc_fs_rate, float BAND_GENSUI_DB, float BANDWIDE_RATE, int mode0)
//
//  mode == 1 ʂ̂ehqtB^[@koe
//  mode == 2 4TvɁiقƂǁjɂȂehqtB^[@koe
//            ́APɁAʂFIRtB^[WC1/8ɐݒ肵́B
//
{
    int i;
    double x0,b0,c0,alfa0,wc0;
   
    com_order2=int((BAND_GENSUI_DB - 8.)/ ( 2.285 *  2. * M_PI *BANDWIDE_RATE ) + 1);
    alfa0= 0.1102 * (BAND_GENSUI_DB - 8.7);
    com_order= 2 * com_order2+1;

    if( mode0 == 2)
    {
      // IɁ@͂߂͗4ɗ̒lɂ邽ߒ𒲐Bcom_order2@FFT4_STEP0̔{ɂB
      com_order2=  int (ceil((double)com_order2 / (double)FFT4_STEP0 )) * FFT4_STEP0;
      com_order= 2 * com_order2+1;
      wc0= 2. * M_PI * (1.0 / 8.0);   
    }
    else wc0= 2. * M_PI * fc_fs_rate;


   if( (fir_lpf1 = (double *)malloc( (com_order+1) * sizeof(double) )  ) == NULL ) return false;

    b0=bessel0(alfa0);
    
     for(i=0;i<com_order2;++i)
    {
      x0 = (double)(com_order2 - i) * wc0;
      x0 = sin( x0) / ( (double)(com_order2-i) * M_PI);
      c0=(double)(com_order2-i) / (double)(com_order2);
      c0=1. - c0*c0;
      c0=sqrt(c0) * alfa0;
      c0=bessel0(c0);
      c0=c0/b0;

      x0= x0 * c0;
      fir_lpf1[i]=x0;
      fir_lpf1[(com_order-1-i)]=x0;
    }
    fir_lpf1[com_order2]=wc0 / M_PI;
    
 // for(i=0;i<com_order;++i) Form2->Memo1->Lines->Add(" No." + IntToStr(i+1) + " value=" + FloatToStr(fir_lpf1[i]) );

    if(mode0 == 2)
    // mode == 2 ̏ꍇ́A_Iɂ̓Z^[̋tɂȂ͂
    {
        gain_hosei1= 1. / fir_lpf1[com_order2];
    }
    else if( (mode0 ==3) || (mode0 ==4)) {gain_hosei1= 1.; }
    else   // ̑̏ꍇ́@SINĎۂɌvZĂ݂B
    {
        b0= fir_lpf1[com_order2];    // SIN( PAI/2)=1.
        x0= 1000.0 / (44100. * 4.);  // 1kHz SIN  1g@2PAI@̃JEg
        x0 = 2. * M_PI * x0;
        for(i=0;i<com_order2;++i)
        {
          if( ((i+1)%FFT4_STEP0) == 0)
          {
           b0 += sin( (M_PI / 2.)  + x0 * (double) i ) * fir_lpf1[com_order2-1-i];
           b0 += sin( (M_PI / 2.)  - x0 * (double) i ) * fir_lpf1[com_order2+1+i];
          }
        }
        gain_hosei1 = 1. / b0; 

    }


     if( mode0 == 2)  // E[͗Ȃ̂Ł@SPđSQ̂mɓ悤ɂĂ܂B
    {
       if( com_order == 65 )    com_order-- ;
        else if( com_order == 129 ) com_order-- ;
        else if( com_order == 257 ) com_order-- ;
        else if( com_order == 513 ) com_order-- ;
    }


      switch(core_number0)
          {
            case 2:
                  Form3->Memo1->Lines->Add(" mode0= " + IntToStr(mode0));
                  Form3->Memo1->Lines->Add(" alfa0= "  + FloatToStr(alfa0) +  " wc0= " + FloatToStr(wc0));
                  Form3->Memo1->Lines->Add(" com_order= "  + IntToStr(com_order) + " com_order2= " + IntToStr(com_order2));
                  Form3->Memo1->Lines->Add(" gain_hosei1= " + FloatToStr(gain_hosei1));
             break;
             default:
                  Form2->Memo1->Lines->Add(" mode0= " + IntToStr(mode0));
                  Form2->Memo1->Lines->Add(" alfa0= "  + FloatToStr(alfa0) +  " wc0= " + FloatToStr(wc0));
                  Form2->Memo1->Lines->Add(" com_order= "  + IntToStr(com_order) + " com_order2= " + IntToStr(com_order2));
                  Form2->Memo1->Lines->Add(" gain_hosei1= " + FloatToStr(gain_hosei1));
          }

    return true;
}
//----------------------------------------------
int TFFT4_class::f_mkdat( int zyou )
{
   int i,z;
   double x;
   double *p,*p0;

   z= f_zyou(zyou);
   if( (p = (double *)malloc( sizeof(double) * z *2 )  ) == NULL)
   {
       return(-1);
   }
    p0=p;
   for(i=0;i<z;++i)
   {
       x= M_PI * 2.0 *(double)i / (double)z;
       *p= cos(x);
       ++p;
       *p= -sin(x);
       ++p;
   }

   //
   mk=p0;
   return(0);
}
//-----------------------------------------------------------------
int TFFT4_class::f_iv_mkdat( int zyou )
/*  inverted data  */
/*  for i-fft             */
{
   int i,z;
   double x;
   double *p,*p0;

   z= f_zyou(zyou);
   if( (p = (double *)malloc( sizeof(double) * z *2 )  ) == NULL)
   {
      return(-1);
  }
    p0=p;
   for(i=0;i<z;++i)
   {
       x= M_PI * 2.0 *(double)i / (double)z;
       *p= cos(x);
       ++p;
       *p= sin(x);
       ++p;
   }
   //
   ivmk=p0;
   return(0);
}
//----------------------------------------------------------------
int TFFT4_class::f_bitrev(int nzyou)
/* data[0]- data[ 2^^nzyou-1]= 2^^nzyou ko   */
{
   int i,j,x1,x;
   int out;
   int kosuu;
   int *p,*p0;

   kosuu=f_zyou(nzyou);
/*
   printf("\n+starts and setting  bit_rev data ");
*/
  if( (p=(int *)malloc( sizeof(int) * kosuu)) == NULL)
   {
      return(-1);
  }
   p0=p;
   for(i=0;i<kosuu;++i)
   {
     out=0;
     x1=i;
     for(j=nzyou;j>0;--j)
     {
        x = x1 & 0x0001;
        out = out + x*f_zyou(j-1);
        x1>>=1;
     }
     *p=out;
     ++p;
   }
   //
   table=p0;
   return(0);
}
//--------------------------------------------------------
void TFFT4_class::f_multc( double *x, double *ws, double *z)
{
   z[0]     = x[0] * ws[0] - x[1] * ws[1];
   z[1]     = x[0] * ws[1] + x[1] * ws[0];
}

//----------------------------------------------------------
void TFFT4_class::f_fftsub(int nh, int offset,int nstep, double datas[], double ws[])
{
   double a[2];
   int i;
   int x1,x2;

   for(i=0;i<nh;++i)
   {
      x1=2*(i+offset);
      x2=2*(i+nh+offset);
      a[0]= datas[x1] - datas[x2];
      a[1]= datas[x1+1] - datas[x2+1];
      datas[x1]   = datas[x1] + datas[x2];
      datas[x1+1] = datas[x1+1] + datas[x2+1];
      datas[x2]   = a[0] * ws[2*i*nstep]   - a[1] * ws[2*i*nstep+1];
      datas[x2+1] = a[0] * ws[2*i*nstep+1] + a[1] * ws[2*i*nstep];
   }
}
//-----------------------------------------------
int TFFT4_class::f_fft(double *datas, int mode, int mode_rev)
{
/****************************/
/* change malloc method     */
/*  attension!!!                                              */
/*  data[2*i]= real-part; data[1+2*i]= imaginaly-part           */
/* kono subroutone wo yobumaeni ws to table wo set suru koto  */
/*                       set_keisuu(ws, nzyou); bit_rev(table, nzyou) */
/*  data suu ha 2^^nzyou*/
/*  *******************************************************************/
/*  iv-fft: set ws as invmkdata, mode==3                              */
/*  When mode_rev < 0, bir revrese does not done                      */
   int n,nh,i,i1,i2,x1,x2,offset;
   double *ws,a[2];


   /* start fft */
   nh=len0;

   if( mode == 3)
   {
     ws= ivmk;   // MODE=3 eiXI
   }
   else ws=mk;

   for(i1=0;i1<nzyoux;++i1)
   {
         nh= nh/2;
         n= f_zyou(i1);

         for(i2=0;i2<n;++i2)
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);
            offset=2*nh*i2;
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a[0]= datas[x1] - datas[x2];
               a[1]= datas[x1+1] - datas[x2+1];
               datas[x1]   = datas[x1] + datas[x2];
               datas[x1+1] = datas[x1+1] + datas[x2+1];
               datas[x2]   = a[0] * ws[2*i*n]   - a[1] * ws[2*i*n+1];
               datas[x2+1] = a[0] * ws[2*i*n+1] + a[1] * ws[2*i*n];
             }
         }
   }

   /* iff 1/N wo kakeru */
   if( mode == 3)
   {
     for(i=0;i<len0;++i)
     {
       datas[2*i]   = datas[2*i] * bn1;
       datas[2*i+1] = datas[2*i+1] * bn1;
     }
   }



   /* irekae */
   if( mode_rev>= 0)
   {
   for(i=0;i<len0;++i)
   {
     i1= table[i];

     if( i < i1)
     {
      a[0] = datas[2*i1];
      a[1] = datas[2*i1+1];

      datas[2*i1]=datas[2*i];
      datas[2*i1+1]=datas[2*i+1];

      datas[2*i]   = a[0];
      datas[2*i+1] = a[1];
     }

    }
   }

   return(0);
}
//------------------------------------------------------------------

int TFFT4_class::f_fft_overlap_add2(short *in0, short *out0, int channel0, int count0)
//
//  *out0 ́@*in@4{̑傫B
//
//  bit revrse ւȂH
{
   int n,nh,i,i1,i2,x1,x2,offset,loop0,sp0;
   double *ws,*datas,a0,a1;
   short *in0p, *out0p;


   ////Form2->Memo1->Lines->Add(" (f_fft_overlap_add2: len0 = " + IntToStr(len0));

   /*@16BIT MDOBLUE֕ϊ */
   // count0<0 ̂Ƃ́@Ԃ͂߂Ł@Oɗ߂Ă
   datas=works;   // WORKgĂ܂vHHH
   in0p=in0;
   if( count0 < 0)
   {  // ̂݁B
      // Õf[^ɂB
      memset((char *) datas, 0, len0 * sizeof(double) );
      // nstep_default-1 ͑O|Ńf[^ĂB
      for(i=(len0_half - (num_hanix-1));i<len0_half;++i)
      {
        if(channel0==1)  // MONO
        {
           datas[2*i]   = (double) *in0p;
           datas[2*i+1] = 0.;
           ++in0p;
        }
        else   // STEREO
        {
           datas[2*i]   = (double) *in0p;
           ++in0p;
           datas[2*i+1]   = (double) *in0p;
           ++in0p;
        }
     }
   }
   else
   {
      memcpy((char *) datas, (char *) works_half,  len0 * sizeof(double) );
   }


   out0p = out0;
   datas=datas+len0;
 
   for(i=len0_half;i<len0;++i)
   {
     if(channel0==1)  // MONO
     {
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
        *datas = 0.;
        ++datas;

     }
     else   // STEREO
     {
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
     }
   }

   // ̂߂Ƀf[^ޔ
    datas=works;
    memcpy((char *) works_half, (char *)(datas + len0) , len0 * sizeof(double));


   
   /* ϊ */
   /* start fft */
   nh=len0_half;
   n=1;
   ws=mk;
   for(i1=0;i1<nzyoux;++i1)
   {


         for(i2=0;i2<n;++i2)     // f_fttsub()2@vZĂ̂Ł@1ȂB
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);
            offset=2 * nh*i2;   // nh@Xebvi2Ԗ
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0= datas[x1] - datas[x2];
               a1= datas[x1+1] - datas[x2+1];
               datas[x1]   = datas[x1] + datas[x2];
               datas[x1+1] = datas[x1+1] + datas[x2+1];

               // 2vZĂ
               datas[x2]   = a0 * ws[2*i*n]   - a1 * ws[2*i*n+1];
               datas[x2+1] = a0 * ws[2*i*n+1] + a1 * ws[2*i*n];
             }
         }
         nh=nh>>1;  //nh=nh/2;
         n=n<<1;    //n=n*2;
   }


   /* ϊlۑB */
   memcpy((char *) works2, (char *) datas,  2 * len0 * sizeof(double) );



 for(loop0= fft4_fil0;loop0< FFT4_STEP0 ;++loop0)
 {
 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(1): loop0 " + IntToStr(loop0));
    datas= works;
    ws=pp0[loop0];


    if( loop0 != fft4_fil0 )
    {
       // ϊlɖ߂B
       memcpy((char *) datas, (char *) works2,  2 * len0 * sizeof(double) );
    }

    
   /* g̈ŏZ */
 for(i=0;i<len0;++i)
 {
    a0= datas[2*i];
     datas[2*i]   = datas[2*i] * ws[2*i] - datas[2*i+1] * ws[2*i+1];
    datas[2*i+1] = datas[2*i+1] * ws[2*i] + a0 * ws[2*i+1];
 }

 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(2): loop0 " + IntToStr(loop0));

  /* tϊ */
  /* start fft */

    ////ws=ivmk;   //// wk ̋𕄍tɂĂB
  ws=mk;
  nh=1;
  n=len0_half;
  for(i1=0;i1<nzyoux;++i1)
  {
         for(i2=0;i2<n;++i2)
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);

            offset=2*nh*i2;
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0   = datas[x2] * ws[2*i*n]   + datas[x2+1] * ws[2*i*n+1];
               a1 = - datas[x2] * ws[2*i*n+1] + datas[x2+1] * ws[2*i*n];
               datas[x2]   = datas[x1] - a0;
               datas[x2+1] =  datas[x1+1] - a1;
               datas[x1]   = datas[x1] + a0;
               datas[x1+1] = datas[x1+1] + a1;
            }

         }
         n=n>>1;    //n=n/2;
         nh=nh<<1;  //nh=nh * 2;
    }

 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(3): loop0 " + IntToStr(loop0));

  
   /*  1/N  */

   if( channel0 == 1) out0p=out0+loop0;
   else out0p=out0+(loop0*2);  // stereo
   datas= works;

   for(i=len0_half;i<len0; ++i)   // Ô͎Ă
   {
      if( channel0 == 1)
      {
        a0 = datas[2*i];
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *out0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *out0p= (short)(a0 - 0.5);  // 45

        }
        out0p+= FFT4_STEP0;
      }
      else
      {  //stereo
        a0 = datas[2*i];  //    * bn1;
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *out0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *out0p= (short)(a0 - 0.5);  // 45
        }
        ++out0p;

        a0 = datas[2*i+1]; //   * bn1;
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *out0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *out0p= (short)(a0 - 0.5);  // 45
        }
        out0p+= FFT4_STEP1;
       } //stereo
   }

   } //  for(loop0=1;loop0<4;++loop0)


   return(0);

}
//  bit revrse ւȂH

//------------------------------------------------------------------
int TFFT4_class::f_fft_overlap_add2d(short *in0, double *out0, int channel0, int count0)
//
//
//  o͂double ɂ́B
//
//  *out0 ́@*in@4{̑傫B
//
//  bit revrse ւȂH
{
   int n,nh,i,i1,i2,x1,x2,offset,loop0,sp0;
   double *ws,*datas,a0,a1;
   short *in0p;
   double  *out0p;


   ////Form2->Memo1->Lines->Add(" (f_fft_overlap_add2: len0 = " + IntToStr(len0));

   /*@16BIT MDOBLUE֕ϊ */
   // count0<0 ̂Ƃ́@Ԃ͂߂Ł@Oɗ߂Ă
   datas=works;   // WORKgĂ܂vHHH
   in0p=in0;
   if( count0 < 0)
   {  // ̂݁B
      // Õf[^ɂB
      memset((char *) datas, 0, len0 * sizeof(double) );
      // nstep_default-1 ͑O|Ńf[^ĂB
      for(i=(len0_half - (num_hanix-1));i<len0_half;++i)
      {
        if(channel0==1)  // MONO
        {
           datas[2*i]   = (double) *in0p;
           datas[2*i+1] = 0.;
           ++in0p;
        }
        else   // STEREO
        {
           datas[2*i]   = (double) *in0p;
           ++in0p;
           datas[2*i+1]   = (double) *in0p;
           ++in0p;
        }
     }
   }
   else
   {
      memcpy((char *) datas, (char *) works_half,  len0 * sizeof(double) );
   }


   out0p = out0;
   datas=datas+len0;
 
   for(i=len0_half;i<len0;++i)
   {
     if(channel0==1)  // MONO
     {
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
        *datas = 0.;
        ++datas;

     }
     else   // STEREO
     {
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
     }
   }

   // ̂߂Ƀf[^ޔ
    datas=works;
    memcpy((char *) works_half, (char *)(datas + len0) , len0 * sizeof(double));



 //SXebvl`ołȂĂ݂B@PȊO͏肭Ȃ̂Œ
  
  if( fft4_fil0 == 1)
  {
    out0p=out0;
   datas= works;
   // (num_hanix-1)@ߋ̃f[^B
   for(i=(len0_half - (num_hanix-1));i<(len0 - (num_hanix-1)); ++i)   // Ô͎Ă
   {
      if( channel0 == 1)
      {
        //a0 = datas[2*i];
        *out0p= datas[2*i];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        // }
        //else
        //{
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //
        //}
        out0p+= FFT4_STEP0;
      }
      else
      {  //stereo
        //a0 = datas[2*i];  //    * bn1;
        *out0p= datas[2*i];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        //}
        //else
        //{
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //}
        ++out0p;

        //a0 = datas[2*i+1]; //   * bn1;
        *out0p= datas[2*i+1];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        //}
        //else
        // {
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //}
        out0p+= FFT4_STEP1;
       } //stereo
   }
   }
   //4Xebvl`o܂


   
   /* ϊ */
   /* start fft */
   nh=len0_half;
   n=1;
   ws=mk;
   for(i1=0;i1<nzyoux;++i1)
   {


         for(i2=0;i2<n;++i2)     // f_fttsub()2@vZĂ̂Ł@1ȂB
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);
            offset=2 * nh*i2;   // nh@Xebvi2Ԗ
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0= datas[x1] - datas[x2];
               a1= datas[x1+1] - datas[x2+1];
               datas[x1]   = datas[x1] + datas[x2];
               datas[x1+1] = datas[x1+1] + datas[x2+1];

               // 2vZĂ
               datas[x2]   = a0 * ws[2*i*n]   - a1 * ws[2*i*n+1];
               datas[x2+1] = a0 * ws[2*i*n+1] + a1 * ws[2*i*n];
             }
         }
         nh=nh>>1;  //nh=nh/2;
         n=n<<1;    //n=n*2;
   }


   /* ϊlۑB */
   memcpy((char *) works2, (char *) datas,  2 * len0 * sizeof(double) );



 for(loop0= fft4_fil0;loop0< fft4_ste0 ;++loop0)
 {
 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(1): loop0 " + IntToStr(loop0));
    datas= works;
    ws=pp0[loop0];


    if( loop0 != fft4_fil0 )
    {
       // ϊlɖ߂B
       memcpy((char *) datas, (char *) works2,  2 * len0 * sizeof(double) );
    }

    
   /* g̈ŏZ */
 for(i=0;i<len0;++i)
 {
    a0= datas[2*i];
     datas[2*i]   = datas[2*i] * ws[2*i] - datas[2*i+1] * ws[2*i+1];
    datas[2*i+1] = datas[2*i+1] * ws[2*i] + a0 * ws[2*i+1];
 }

 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(2): loop0 " + IntToStr(loop0));

  /* tϊ */
  /* start fft */

    ////ws=ivmk;   //// wk ̋𕄍tɂĂB
  ws=mk;
  nh=1;
  n=len0_half;
  for(i1=0;i1<nzyoux;++i1)
  {
         for(i2=0;i2<n;++i2)
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);

            offset=2*nh*i2;
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0   = datas[x2] * ws[2*i*n]   + datas[x2+1] * ws[2*i*n+1];
               a1 = - datas[x2] * ws[2*i*n+1] + datas[x2+1] * ws[2*i*n];
               datas[x2]   = datas[x1] - a0;
               datas[x2+1] =  datas[x1+1] - a1;
               datas[x1]   = datas[x1] + a0;
               datas[x1+1] = datas[x1+1] + a1;
            }

         }
         n=n>>1;    //n=n/2;
         nh=nh<<1;  //nh=nh * 2;
    }

 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(3): loop0 " + IntToStr(loop0));

  
   /*  1/N  */

   if( channel0 == 1) out0p=out0+loop0;
   else out0p=out0+(loop0*2);  // stereo
   datas= works;

 
   x1= fft4_ste0 * -1;
   for(i=len0_half;i<len0; ++i)   // Ô͎Ă
   {
      if( channel0 == 1)
      {
        //a0 = datas[2*i];
        *out0p= datas[2*i];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        // }
        //else
        //{
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //
        //}
        out0p+= fft4_ste0;
      }
      else
      {  //stereo
        //a0 = datas[2*i];  //    * bn1;
        *out0p= datas[2*i];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        //}
        //else
        //{
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //}
        ++out0p;

        //a0 = datas[2*i+1]; //   * bn1;
        *out0p= datas[2*i+1];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        //}
        //else
        // {
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //}
        out0p+= x1;   //FFT4_STEP1;
       } //stereo
   }



   } //  for(loop0=1;loop0<4;++loop0)


   return(0);

}
//  bit revrse ւȂH
//------------------------------------------------------------------
int TFFT4_class::f_fft_overlap_add2dd(double *in0, double *out0, int channel0, int count0)
//
//
//  o͂double ɂ́B  ͂double ɂ́B
//
//  *out0 ́@*in@4{̑傫B
//
//  bit revrse ւȂH
{
   int n,nh,i,i1,i2,x1,x2,offset,loop0,sp0;
   double *ws,*datas,a0,a1;
   double *in0p;
   double  *out0p;




   
   ////Form2->Memo1->Lines->Add(" (f_fft_overlap_add2: len0 = " + IntToStr(len0));
   ////Form2->Memo1->Lines->Add("fft4_fil0 = " + IntToStr(fft4_fil0)  + "fft4_ste0 = " + IntToStr(fft4_ste0));

   /*@16BIT MDOBLUE֕ϊ */
   // count0<0 ̂Ƃ́@Ԃ͂߂Ł@Oɗ߂Ă
   datas=works;   // WORKgĂ܂vHHH
   in0p=in0;
   if( count0 < 0)
   {  // ̂݁B
      // Õf[^ɂB
      memset((char *) datas, 0, len0 * sizeof(double) );
      // nstep_default-1 ͑O|Ńf[^ĂB
      for(i=(len0_half - (num_hanix-1));i<len0_half;++i)
      {
        if(channel0==1)  // MONO
        {
           datas[2*i]   =  *in0p;
           datas[2*i+1] = 0.;
           ++in0p;
        }
        else   // STEREO
        {
           datas[2*i]   =  *in0p;
           ++in0p;
           datas[2*i+1]   = *in0p;
           ++in0p;
        }
     }
   }
   else
   {
      memcpy((char *) datas, (char *) works_half,  len0 * sizeof(double) );
   }


   out0p = out0;
   datas=datas+len0;
 
   for(i=len0_half;i<len0;++i)
   {
     if(channel0==1)  // MONO
     {
        *datas   =  *in0p;
        ++datas;
        ++in0p;
        *datas = 0.;
        ++datas;

     }
     else   // STEREO
     {
        *datas   =  *in0p;
        ++datas;
        ++in0p;
        *datas   =  *in0p;
        ++datas;
        ++in0p;
     }
   }


  
   // ̂߂Ƀf[^ޔ
    datas=works;
    memcpy((char *) works_half, (char *)(datas + len0) , len0 * sizeof(double));



 //SXebvl`ołȂĂ݂B@PȊO͏肭Ȃ̂Œ
  
  if( fft4_fil0 == 1)
  {
    out0p=out0;
   datas= works;
   // (num_hanix-1)@ߋ̃f[^B
   for(i=(len0_half - (num_hanix-1));i<(len0 - (num_hanix-1)); ++i)   // Ô͎Ă
   {
      if( channel0 == 1)
      {
        //a0 = datas[2*i];
        *out0p= datas[2*i];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        // }
        //else
        //{
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //
        //}
        out0p+= fft4_ste0;  //FFT4_STEP0;
      }
      else
      {  //stereo
        //a0 = datas[2*i];  //    * bn1;
        *out0p= datas[2*i];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        //}
        //else
        //{
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //}
        ++out0p;

        //a0 = datas[2*i+1]; //   * bn1;
        *out0p= datas[2*i+1];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        //}
        //else
        // {
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //}
        out0p+= (2 * fft4_ste0 -1);  //FFT4_STEP1;
       } //stereo
   }
   }
   //4Xebvl`o܂


   
   /* ϊ */
   /* start fft */
   nh=len0_half;
   n=1;
   ws=mk;
   for(i1=0;i1<nzyoux;++i1)
   {


         for(i2=0;i2<n;++i2)     // f_fttsub()2@vZĂ̂Ł@1ȂB
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);
            offset=2 * nh*i2;   // nh@Xebvi2Ԗ
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0= datas[x1] - datas[x2];
               a1= datas[x1+1] - datas[x2+1];
               datas[x1]   = datas[x1] + datas[x2];
               datas[x1+1] = datas[x1+1] + datas[x2+1];

               // 2vZĂ
               datas[x2]   = a0 * ws[2*i*n]   - a1 * ws[2*i*n+1];
               datas[x2+1] = a0 * ws[2*i*n+1] + a1 * ws[2*i*n];
             }
         }
         nh=nh>>1;  //nh=nh/2;
         n=n<<1;    //n=n*2;
   }


   /* ϊlۑB */
   memcpy((char *) works2, (char *) datas,  2 * len0 * sizeof(double) );



 
 for(loop0= fft4_fil0;loop0< fft4_ste0 ;++loop0)
 {
 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(1): loop0 " + IntToStr(loop0));
    datas= works;
    ws=pp0[loop0];


    if( loop0 != fft4_fil0 )
    {
       // ϊlɖ߂B
       memcpy((char *) datas, (char *) works2,  2 * len0 * sizeof(double) );
    }

    
   /* g̈ŏZ */
 for(i=0;i<len0;++i)
 {
    a0= datas[2*i];
     datas[2*i]   = datas[2*i] * ws[2*i] - datas[2*i+1] * ws[2*i+1];
    datas[2*i+1] = datas[2*i+1] * ws[2*i] + a0 * ws[2*i+1];
 }

 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(2): loop0 " + IntToStr(loop0));

  /* tϊ */
  /* start fft */

    ////ws=ivmk;   //// wk ̋𕄍tɂĂB
  ws=mk;
  nh=1;
  n=len0_half;
  for(i1=0;i1<nzyoux;++i1)
  {
         for(i2=0;i2<n;++i2)
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);

            offset=2*nh*i2;
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0   = datas[x2] * ws[2*i*n]   + datas[x2+1] * ws[2*i*n+1];
               a1 = - datas[x2] * ws[2*i*n+1] + datas[x2+1] * ws[2*i*n];
               datas[x2]   = datas[x1] - a0;
               datas[x2+1] =  datas[x1+1] - a1;
               datas[x1]   = datas[x1] + a0;
               datas[x1+1] = datas[x1+1] + a1;
            }

         }
         n=n>>1;    //n=n/2;
         nh=nh<<1;  //nh=nh * 2;
    }

 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(3): loop0 " + IntToStr(loop0));

  
   /*  1/N  */

   if( channel0 == 1) out0p=out0+loop0;
   else out0p=out0+(loop0*2);  // stereo
   datas= works;

 
   x1= (2 * fft4_ste0 -1);
   for(i=len0_half;i<len0; ++i)   // Ô͎Ă
   {
      if( channel0 == 1)
      {
        //a0 = datas[2*i];
        *out0p= datas[2*i];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        // }
        //else
        //{
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //
        //}
        out0p+= fft4_ste0;
      }
      else
      {  //stereo
        //a0 = datas[2*i];  //    * bn1;
        *out0p= datas[2*i];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        //}
        //else
        //{
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //}
        ++out0p;

        //a0 = datas[2*i+1]; //   * bn1;
        *out0p= datas[2*i+1];
        //if(a0 >=0)
        //{
        //     if(a0 > 32767.) a0=32767.;
        //     *out0p= (short)(a0 + 0.5);   // 45
        //}
        //else
        // {
        //     if(a0 < -32768.) a0=-32768.;
        //     *out0p= (short)(a0 - 0.5);  // 45
        //}
        out0p+= x1;   //FFT4_STEP1;
       } //stereo
   }



   } //  for(loop0=1;loop0<4;++loop0)


   return(0);

}
//  bit revrse ւȂH
//--------------------------------------------------------------------
int TFFT4_class::f_4p_map(short *in0, short *out0, int channel0, int size0, bool first_flag0, int mode0)
{

 int i,c0;
 char *cp0;
 short *sp0;



     c0=size0/channel0;

     if(first_flag0)
     {
     for(i=0;i<c0;++i)
     {
        if(channel0 == 1)
        {
           out0[ FFT4_STEP0 *i]=in0[i];
        }
        else
        {
           out0[2*( FFT4_STEP0 *i)]  = in0[2 * i];
           out0[2*( FFT4_STEP0 *i)+1]= in0[2 * i + 1];
        }
     }

     cp0=(char *)in0;
     cp0 += (size0 * sizeof(short));
     memcpy((char *)iwork_half, cp0, (num_hanix-1) * channel0 * sizeof(short));
     }
     else
     {
       sp0=in0;
       for(i=0;i<c0;++i)
       {
          if(i< (num_hanix-1))
          {
            if(channel0 == 1)
            {
               out0[ FFT4_STEP0 *i]=iwork_half[i];
            }
            else
            {
               out0[2*( FFT4_STEP0 *i )]  = iwork_half[2 * i];
               out0[2*( FFT4_STEP0 * i) + 1]= iwork_half[2 * i + 1];
            }
        }
        else
       {
        if(channel0 == 1)
        {
          out0[ FFT4_STEP0 *i]=*sp0;
          ++sp0;
        }
        else
        {
          out0[2*( FFT4_STEP0 *i)]  = *sp0;
          ++sp0;
          out0[2*( FFT4_STEP0 *i)+1]= *sp0;
          ++sp0;
        }
       }
     }
      cp0=(char *)sp0;
      memcpy((char *)iwork_half, cp0, (num_hanix-1) * channel0 * sizeof(short));
     }
  

 return 0;
}
//--------------------------------------------------------------------
