//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <stdlib.h> 
#include <fcntl.h> // t@C̓ǂݏ֌Wwb_
#include <io.h>
#include <sys\stat.h>
#include <math.h>
#include <mmreg.h> //WINDOWS@EGCu֌W̃wb_[t@C
#include <mem.h>



#include "main1.h"



//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

#include "CFilter.h"
CFILTER  *filter_com01;
CFILTER  *filter_com02;

//--------------------------------------------------

#include "CDFT_HIBERT.h"   // b@eXgp
TCDFT_HIBERT  *cdft_hibert01;
#include "Window_Class.h"
TWINDOWS_class *WINDOWS_class01;


#include "Unit2.h"
#include "Unit3.h"
//============================================================================
// Sampling Rate Convertor   based  on  sampling theorem
//
//          n=+mugendai
//   x(t)= sigma x(nT) *  sin (%pai * fs* ( t - nT)) / (%pai * fs* ( t - nT))
//          n=-mugendai
//----------------------------------------------------------------------------
//                        +NSTEP0
//                x(t)  ~= sigma x(nT) * sinc(%pai * fs* ( t - nT))
//                        n=-NSTEP0
//                    ----------------------
//                When converts from high frequency to lower one, 
//                applys linear-phase fir low pass filter before above formula
//                  in order to reduce to signals under new sampling frequency.
//-----------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

    Application->Title="SRC";
    FileList = new TStringList;

    if( FileExists("src01.exe"))
    {
      ComboBox1->Text="44100";
      Edit3->Text=ComboBox1->Text;
       Application->MessageBox("̃vO͕W{藝ɂƂÂāASINC̐ϘavZɂā@TvO[gϊ̂łB̕ۏ͂܂BAf[^ȂǂĂӔCĂ܂̂Ł@炸B","",MB_OK);

    }
    else
    {
    Edit3->Text=ComboBox1->Text;
    Button5->Visible=false;
    CheckBox4->Visible=false;
    CheckBox5->Visible=false;
    CheckBox6->Visible=false;
    CheckBox7->Visible=false;
    CheckBox6->Checked=false;
    //Label13->Visible=false;
    //Edit9->Visible=false;
    ProgressBar2->Visible=false;
    Edit11->Visible=false;
    Edit12->Visible=false;
    Label15->Visible=false;
    Label16->Visible=false;

    Application->MessageBox("̃vO͕W{藝ɂƂÂāASINC̐ϘavZɂā@TvO[gϊ̂łB̕ۏ͂܂BAf[^ȂǂĂӔCĂ܂̂Ł@炸B","",MB_OK);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{

    char szFileName[1000];

     if( OpenDialog1->Execute())
    {

        Form2->Memo1->Lines->Add(OpenDialog1->FileName);
        Form2->Memo1->Lines->Add(ExtractFileDir(OpenDialog1->FileName));
        Edit1->Text=OpenDialog1->FileName;


        Edit2->Text=OpenDialog1->FileName.SubString(1,OpenDialog1->FileName.Length()-4) + Edit8->Text + ".wav";

        //
        CFILTER  *filter01;
        filter01 = new CFILTER(true);
        filter01->action_type=ONLY_READ1ST;
        filter01->core_number=1;
        filter01->Resume();
         

    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   Close();         
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{

    SaveDialog1->FileName=ExtractFileName(Edit2->Text);

    
    if( SaveDialog1->Execute())
    {
       //if( FileExists(SaveDialog1->FileName))
       //{
          //if( Application->MessageBox("Ƀt@C݂܂B폜܂BOKłH", "mF", MB_OKCANCEL) == IDOK)
          //{
          // DeleteFile(SaveDialog1->FileName);
           Edit2->Text=SaveDialog1->FileName;
          //}
       //}
       //else Edit2->Text=SaveDialog1->FileName;
       Edit2->Text=SaveDialog1->FileName;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Click(TObject *Sender)
{
   Edit3->Text = ComboBox1->Items->Strings[ComboBox1->ItemIndex];
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
 int i,c0;


  if( CheckTextValue0())
  {
     if( CheckBox4->Checked)
     {
       if( CheckBox7->Checked)
       // for dual core
       {
        pickup_filelist();
        filter_com01 = new CFILTER(true);
        filter_com01->action_type=SRC_GO_WITH_FIR_FILES;
        filter_com01->core_number=1;
        filter_com01->Resume();
        
        filter_com02 = new CFILTER(true);
        filter_com02->action_type=SRC_GO_WITH_FIR_FILES;
        filter_com02->core_number=2;
        filter_com02->Resume();
       }
       else
       // for normal for single core
       {
        pickup_filelist();
        filter_com01 = new CFILTER(true);
        filter_com01->action_type=SRC_GO_WITH_FIR_FILES;
        filter_com01->core_number=1;
        filter_com01->Resume();
       }
     }
     else
     {
        filter_com01 = new CFILTER(true);
        filter_com01->action_type=SRC_GO;
        filter_com01->Resume();
     }
  }


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{

  if( CheckBox7->Checked)
  {
   if(Form3->Visible==true) Form3->Visible=false;
   else Form3->Visible=true;
  }

   if(Form2->Visible==true) Form2->Visible=false;
   else Form2->Visible=true;

}
//---------------------------------------------------------------------------
bool __fastcall TForm1::CheckTextValue0()
{
  int      dummy0;
  double   ddummy0;


  //(1)
  try
  {
    dummy0 = Edit3->Text.ToInt();
  }
  catch( EConvertError &e)
  {
    Application->MessageBox("TvOgfsł͂܂B","G[",MB_OK);
    return false;
  }

  if(dummy0 < 1 )
  {
    Application->MessageBox("TvOgfs̐ł͂܂B","G[",MB_OK);
    return false;
  }

  //(2)
  try
  {
    dummy0 = Edit7->Text.ToInt();
  }
  catch( EConvertError &e)
  {
    Application->MessageBox("ϘavZw͈̔͂ł͂܂B","G[",MB_OK);
    return false;
  }

  if(dummy0 < 1 )
  {
    Application->MessageBox("ϘavZw͈̔͂̐ł͂܂B","G[",MB_OK);
    return false;
  }

  //(3)
  try
  {
    dummy0 = Edit5->Text.ToInt();
  }
  catch( EConvertError &e)
  {
    Application->MessageBox("ʂł͂܂B","G[",MB_OK);
    return false;
  }

  if(dummy0 < 50 )
  {
    Application->MessageBox("ʂ50ȏ̐̐ł͂܂B","G[",MB_OK);
    return false;
  }

   //(4)
  try
  {
    ddummy0 = Edit6->Text.ToDouble();
  }
  catch( EConvertError &e)
  {
    Application->MessageBox("ʉ߈悪ł͂܂B","G[",MB_OK);
    return false;
  }

  if((ddummy0 > 0) && (ddummy0 < 1.0) )
  {
  }
  else
  {
    Application->MessageBox("ʉ߈悪0`1͈̔͂ł͂܂B","G[",MB_OK);
    return false;
  }

   //(5)
  try
  {
    dummy0 = Edit9->Text.ToInt();
  }
  catch( EConvertError &e)
  {
    Application->MessageBox("sin e[ȗ傫ł͂܂B","G[",MB_OK);
    return false;
  }

  if(dummy0 < 1 )
  {
    Application->MessageBox("sin e[ȗ傫̐ł͂܂B","G[",MB_OK);
    return false;
  }


  return true;
}
//---------------------------------------------------------------------
void __fastcall TForm1::pickup_filelist()
{


  input_dir=ExtractFileDir(Edit1->Text);
  output_dir=ExtractFileDir(Edit2->Text);
  FileList->Clear();
  FileList->Add(ExtractFileName(Edit1->Text));  //@TEXT@BOX̕\t@C擪ɉB

  WIN32_FIND_DATA fd;  // 񋓏擾p
  AnsiString Pattern = input_dir+"\\*.wav";  //  ChJ[hőSt@C
  HANDLE hFind;   // p̃nh

  hFind = FindFirstFile(Pattern.c_str(),&fd); // ŏ̃t@C
  if(hFind==INVALID_HANDLE_VALUE)
    return;  // t@C͂P݂Ȃ(ۂ . ..̂ŎsȂ͂)

  do{


    if(strcmp(fd.cFileName,".")!=0 && strcmp(fd.cFileName,"..")!=0)
    { // . ..͖


      if(strcmp(fd.cFileName, FileList->Strings[0].c_str())!=0)
      {
        FileList->Add(fd.cFileName);
      }
      /////Form2->Memo1->Lines->Add(fd.cFileName);   // m[hɃt@Cǉ


      if(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
      { // tH_ׂ
      //  AnsiString SubFolder;
      //
      //  SubFolder = DirName+"\\"+fd.cFileName;  //݂̃tH_ɌtH_ǉ
      //  EnumFolders(SubFolder,Node);  // TutH_
      }
    }
  }while(FindNextFile(hFind,&fd)==true);  // t@CȂ܂ő

  FindClose(hFind);  //nh

  //------------------
  int  i;

  if( CheckBox7->Checked)
  // for dual core
  {
   Form2->Memo1->Lines->Add(" ");
   Form3->Memo1->Lines->Add(" ");
   Form2->Memo1->Lines->Add("quantity of files =" + IntToStr(FileList->Count));
   Form3->Memo1->Lines->Add("quantity of files =" + IntToStr(FileList->Count));
   for(i=0;i<FileList->Count;++i)
   {
     Form2->Memo1->Lines->Add(FileList->Strings[i]);
     Form3->Memo1->Lines->Add(FileList->Strings[i]);
   }
  }
  else // normal
  {
   Form2->Memo1->Lines->Add(" ");
   Form2->Memo1->Lines->Add("quantity of files =" + IntToStr(FileList->Count));
   for(i=0;i<FileList->Count;++i)
   {
     Form2->Memo1->Lines->Add(FileList->Strings[i]);
   }
  }



}
//---------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    FileList->Clear();
    delete FileList;

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button6Click(TObject *Sender)
{
  // for core b
  char szFileName[1000];

     if( OpenDialog1->Execute())
    {

        Form2->Memo1->Lines->Add(OpenDialog1->FileName);
        Form2->Memo1->Lines->Add(ExtractFileDir(OpenDialog1->FileName));
        Edit11->Text=OpenDialog1->FileName;


        Edit12->Text=OpenDialog1->FileName.SubString(1,OpenDialog1->FileName.Length()-4) + Edit8->Text + ".wav";

        //
        CFILTER  *filter02;
        filter02 = new CFILTER(true);
        filter02->action_type=ONLY_READ1ST;
        filter02->core_number=2;   // for core b
        filter02->Resume();
         

    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
 // for dual core b
 SaveDialog1->FileName=ExtractFileName(Edit12->Text);

    
    if( SaveDialog1->Execute())
    {
       //if( FileExists(SaveDialog1->FileName))
       //{
          //if( Application->MessageBox("Ƀt@C݂܂B폜܂BOKłH", "mF", MB_OKCANCEL) == IDOK)
          //{
          // DeleteFile(SaveDialog1->FileName);
           Edit12->Text=SaveDialog1->FileName;
          //}
       //}
       //else Edit2->Text=SaveDialog1->FileName;
       Edit12->Text=SaveDialog1->FileName;
    }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::CheckBox9Click(TObject *Sender)
{
 //FFT overlap save 4{̂Ƃ
   if( CheckBox9->Checked)
   {
     // MONOɂOFFɂ
     CheckBox1->Checked=false;
     //CheckBox1->Visible=false;
     // tB^[OFFɂ
     CheckBox2->Checked=false;
     //CheckBox2->Visible=false;

     // rIÎ߁@OFF
     CheckBox8->Checked=false;
     CheckBox10->Checked=false;
   }
   else
   {
     CheckBox1->Visible=true;
     CheckBox2->Visible=true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox10Click(TObject *Sender)
{
 //FFT overlap save 4{̂Ƃ
   if( CheckBox10->Checked)
   {
     // MONOɂOFFɂ
     CheckBox1->Checked=false;
     //CheckBox1->Visible=false;
     // tB^[OFFɂ
     CheckBox2->Checked=false;
     //CheckBox2->Visible=false;

     // rIÎ߁@OFF
     CheckBox8->Checked=false;
     CheckBox9->Checked=false;
   }
   else
   {
     CheckBox1->Visible=true;
     CheckBox2->Visible=true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox12Click(TObject *Sender)
{
    if(CheckBox12->Checked) CheckBox2->Checked=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox11Click(TObject *Sender)
{
    if( CheckBox11->Checked)  Edit5->Text="110";
    else Edit5->Text="100";
           
}
//---------------------------------------------------------------------------




