//---------------------------------------------------------------------------

#ifndef FFT4_classH
#define FFT4_classH


#define FFT4_STEP0 4      // 4|Cg
#define FFT4_STEP1 7      // XeIM 2 * FFT4_STEP0 - 1Vtg
#define FFT4_FIL0A  1      // FFT_FIL0 @FFT4_STEP0|P̃XebvFFTvZ
#define FFT4_FIL0B  0      // FFT_FIL0B @FFT4_STEP0|P̃XebvFFTvZ

//---------------------------------------------------------------------------
class TFFT4_class
{

public:
    TFFT4_class(int num_hani, float fc_fs_rate, float BAND_GENSUI_DB, float BANDWIDE_RATE, int mode0, int core_number);
    ~TFFT4_class();

    int f_fft( double *datas, int mode, int mode_rev);
    int f_fft_overlap_add2(short *in0, short *out, int channel0, int count0);
    int f_fft_overlap_add2d(short *in0, double *out, int channel0, int count0);
    int f_fft_overlap_add2dd(double *in0, double *out, int channel0, int count0);
    int f_4p_map(short *in0, short *out0, int channel0, int size0, bool  first_flag0, int mode0);
    int return_com_order0() { return com_order; }  // FIR LPF ̑SԂ
    int return_num_hanix()  { return num_hanix; }  // gĂlԂ
    int return_com_order2() { return com_order2; }
    int return_nzyou0() { return nzyou0; }
    int return_len0()  { return len0; }
    int return_len0_half()  { return len0_half; }  //̒PʂŃf[^̓Vtg
    int rt_code0;
    
    

private:
    int f_zyou( int zyou);
    int f_mkdat( int n);
    int f_iv_mkdat( int n); /* inv  */
    int f_bitrev( int n);
    void f_multc( double *x, double *ws, double *z);
    void f_fftsub(int nh, int offset,int nstep, double datas[], double ws[]);
    double bessel0(double x0);
    bool init_fir_lpf1(float fc_fs_rate, float BAND_GENSUI_DB, float BANDWIDE_RATE, int mode0);
    int    com_order,com_order2, nfir_1_4;
    double gain_hosei1;
    double *fir_lpf1;
    bool   use_fir_lpf1_flag;
    int    fft4_fil0,fft4_ste0;
    int len0,len0_half;
    double *mk;
    double *ivmk;
    double *kaiser_lpf, *kaiser_lpf2, *kaiser_lpf3;
    int    *table;
    double *works, *works2;
    double *works_half;
    double bn1,bn2;
    int nzyou0,nzyoux;
    int num_hanix;
    short *iwork_half;
    double *pp0[16];
    int core_number0;

    

};
#endif
